include( "./stepanbarta.jl")

using CSV
using DataFrames
using FileIO

# path for MP3 files
const mp3path = "./dataset_mp3/"
const wavpath = "./dataset_wav/"
const mel_spectrograms = "./mel_spectrograms/"
const sample_frequency = 32000
const source_metadata = "metadata.csv"
const dest_metadata = "metadata-10s.csv"

function genmelspectrograms( source_file )
    start = 2
    step  = 10
    
    space = -2
    result = []

    while start+step <= 35 
        result = push!(result, stepanbarta.melSpectrgrmFromWav( wavpath, source_file, mel_spectrograms, sample_frequency, start, step ) )
        start += step + space
    end
        
    return result, length( result )
end


function loadData()
    file = CSV.File( open(source_metadata), skipto=2 )
    spectrograms = []
    birds = []

    # for each MP3 record in CSV list
    for i in file
        # convert source file to WAV
        filename = i[61][6:length(i[61])]
        test_conv = stepanbarta.mp3towav( "$mp3path$filename", "$wavpath$filename.wav", sample_frequency )

        # if conversion was successful, gen mel scpectrograms and delete souce wav file
        if ( test_conv )
            result, len = genmelspectrograms( "$filename.wav")

            append!(spectrograms, result )
            
            for j in 1:len
                push!(birds, i[60])
            end

            rm("$wavpath$filename.wav")
        end
    end
    
    return spectrograms, birds
end

x, y = loadData()

function createDataFrame()
    df = DataFrame(name = String[], surname = String[])
    for i in 1:length(x)
        push!( df, [x[i] y[i]] )
    end 
    return df
end

df_final = createDataFrame()

CSV.write(dest_metadata, df_final )
