using CSV
using Images, FileIO, JSON
#using Flux, Statistics, Plots 
#using Flux: onehotbatch

const source_10s_metadata = "metadata-10s.csv"
const mel_spectrograms = "./mel_spectrograms/"
const dest_dataset = "dataset-10s-augmented.jld2"

function load_data()
    csv_data = CSV.File(source_10s_metadata)
    
    m_train = convert(Array{Float32}, zeros(128,128,0) )
    m_test = convert(Array{Float32}, zeros(128,128,0) )
    o_train = []
    o_test = []

    original_labels = []

    for i in 1:length(csv_data)
        n = csv_data[:name][i]
        println(n)

        img = load("$mel_spectrograms$n")
        img2 = Gray.(img)

        # to validation use only non-augmented data
        if rand(Float16) < 0.2  
            m_test = cat( m_test, convert(Matrix{Float32}, img2), dims=3 )
            push!(o_test, csv_data[:surname][i])
        else
            # get image before augmentation
            augim =  convert(Matrix{Float32}, img2);
            m_train = cat( m_train, augim, dims=3 )
            push!(o_train, csv_data[:surname][i])

            #augmentation
            start = rand(1:100)
            width = rand(2:10)
            augim[:,start:start+width] .= 0.5;
            start = rand(1:100)
            width = rand(2:10)
            augim[:,start:start+width] .= 0.5;

            start = rand(1:100)
            width = rand(2:10)
            augim[start:start+width,:] .= 0.5;
            start = rand(1:100)
            width = rand(2:10)
            augim[start:start+width,:] .= 0.5;
            
            m_train = cat( m_train, augim, dims=3 )
            push!(o_train, csv_data[:surname][i])

        end

        if csv_data[:surname][i] ∉ original_labels
            push!(original_labels, csv_data[:surname][i] )
        end
        
    end
    println("obrazky nactene")
    return m_train, o_train, m_test, o_test, original_labels
end

train_data, train_labels, test_data, test_labels, original_labels = load_data()

save(dest_dataset, 
    "train_data", train_data, "test_data", test_data, 
    "train_labels", JSON.json(train_labels), "test_labels", JSON.json( test_labels ),
    "original_labels", JSON.json( original_labels ) )
