using CSV
using Images, FileIO, JSON

const mel_spectrograms = "./mel_spectrograms/"
const source_10s_metadata = "metadata-10s.csv"
const dest_dataset = "dataset-10s-non-augment.jld2"

function load_data(path)
    csv_data = CSV.File(source_10s_metadata)
    
    m_train = convert( Array{Float32}, zeros(128,128,0) )
    m_test = convert( Array{Float32}, zeros(128,128,0) )
    o_train = []
    o_test = []

    original_labels = []

    for i in 1:length(csv_data)
        n = csv_data[:name][i]

        img = load("$mel_spectrograms$n")
        img2 = Gray.(img)

        println(n)
        
        # 20% of samples to validation part
        if rand(Float16) < 0.2  
            m_test = cat( m_test, convert(Matrix{Float32}, img2), dims=3 )
            push!(o_test, csv_data[:surname][i])
        else
            m_train = cat( m_train, convert(Matrix{Float32}, img2), dims=3 )
            push!(o_train, csv_data[:surname][i])
        end

        if csv_data[:surname][i] ∉ original_labels
            push!(original_labels, csv_data[:surname][i] )
        end
        
    end
    println("dataset prepared")
    return m_train, o_train, m_test, o_test, original_labels
end

train_data, train_labels, test_data, test_labels, original_labels = load_data(mel_spectrograms)

save( dest_dataset, 
    "train_data", train_data, "test_data", test_data, 
    "train_labels", JSON.json(train_labels), "test_labels", JSON.json( test_labels ),
    "original_labels", JSON.json( original_labels ) )

